# $Id: 1.t,v 1.2 2003/08/26 22:21:34 mrodrigu Exp $
# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl 1.t'

#########################

# change 'tests => 1' to 'tests => last_test_to_print';

use Test::More qw( no_plan);
BEGIN { use_ok('Format::FileSize') };

#########################

my %size=( K => 1024, M => 1024 ** 2, G => 1024 ** 3, T => 1024 ** 4, P => 1024 ** 5);

while( <DATA>)
  { chomp;
    s{#.*$}{};
    s{\s*$}{};
    next unless( m{\t});

    my( $size, $expected, $options)= split /\t+/;

    my %options= eval( $options);

    my $expanded_size= $size;
    $expanded_size=~ s{([KMGTP])}{* $size{$1}}g;
    my $computed_size= eval( $expanded_size);
    my $result= formatted_size( $computed_size, %options);

    is( $result, $expected) or diag( "formatted_size($size, $options) ($computed_size): should be /$expected/, is /$result/ (real precision= $Format::FileSize::saved_precision)");
  }

__DATA__
0							0
1							1
5							5
1023						1023
1024						1 K
1025						1 K
1024+(1024/100)+1			1.01 K
1024+(1024/10)				1.09 K
1024+(1024/10)+1			1.10 K
1024*1024					1 M
1024*1024+(1024/100)		1 M
1024*1024+((1024*1024)/100)+1		1.01 M
1024*1024*1024 - 1			1023 M
1024*1024*1024				1 G
1024*1024*1024 + (1024*1024*1024)/5 + 1	1.20 G

1M						1 M
1G - 1					1023 M
1G + 100M				1.09 G
1T + 1M					1 T
1.1G+1					1.10 G
10.01G+1				10 G
10.1G+1					10.1 G
100.1G+1				100 G

0						0		precision => 0
1						1		precision => 0
5						5		precision => 0
1K-1					1023	precision => 0
1K						1 K		precision => 0
1K+1					1 K		precision => 0
1K+(1K/100)+1			1 K		precision => 0
1M+1M/100+1				1 M		precision => 0
1M+ 1M/3				1.33 M	precision => 2
1M+ 1M/3				1 M		precision => 0


0						0		precision => 1
1						1		precision => 1
5						5		precision => 1
1K-1					1023	precision => 1
1K						1.0 K	precision => 1
1K+1					1.0 K	precision => 1
1K+(1K/10)+1			1.1 K	precision => 1
1M+1M/100+1				1.0 M	precision => 1
1M+ 1M/3				1.3 M	precision => 1
1K+(1K/20)-1			1.0 K	precision => 1

0						0		precision => 2
1						1		precision => 0
5						5		precision => 2
1K-1					1023	precision => 0
1K						1.000 K	precision => 3
1K+1					1 K		precision => 0
1K+(1K/10)+1			1.100 K	precision => 3
1M+1M/100+1				1.01 M	precision => 2
1M+ 1M/3				1 M		precision => 0

1K						1 Kb	symbols => [ '', ' Kb', ' Mb', ' Gb', ' Tb']
1M						1 Mb	symbols => [ '', ' Kb', ' Mb', ' Gb', ' Tb']
10.35M+1					10.3 Mb	symbols => [ '', ' Kb', ' Mb', ' Gb', ' Tb']
10.35M+1					10.35 Mb	precision => 2, symbols => [ '', ' Kb', ' Mb', ' Gb', ' Tb']
10.35M+1					10.350 Mb	precision => 3, symbols => [ '', ' Kb', ' Mb', ' Gb', ' Tb']
10.35M+1					10.3500 Mb	precision => 4, symbols => [ '', ' Kb', ' Mb', ' Gb', ' Tb']
1G						1 Gb	symbols => [ '', ' Kb', ' Mb', ' Gb', ' Tb']
10T						10 Tb	symbols => [ '', ' Kb', ' Mb', ' Gb', ' Tb']
10000T					10000 Tb	symbols => [ '', ' Kb', ' Mb', ' Gb', ' Tb']

1G-1					1023 M
1G-1					1023.9 M	precision => 1

